package tags_test

import (
	"testing"

	"github.com/stretchr/testify/assert"

	"git.golang1.ru/softonik/godog/internal/tags"
)

type testcaseF struct {
	filter   string
	input    []*pickle
	expected []*pickle
}

var testdataNonF = []*pickle{p1n, p2n, p3n}
var testdataF = []*pickle{p1n, p2n, p3withF}
var p1n = &pickle{Id: "one", Tags: []*tag{}}
var p2n = &pickle{Id: "two", Tags: []*tag{{Name: "@wip"}}}
var p3n = &pickle{Id: "three", Tags: []*tag{}}
var p3withF = &pickle{Id: "three", Tags: []*tag{{Name: "@f"}}}

var testcasesF = []testcaseF{
	{filter: "", input: testdataNonF, expected: testdataNonF},
	{filter: "", input: testdataF, expected: []*pickle{p3withF}},
	{filter: "@wip", input: testdataF, expected: []*pickle{p2n}},
}

func Test_ApplyTagFilterWithF(t *testing.T) {
	for _, tc := range testcasesF {
		t.Run("", func(t *testing.T) {
			actual := tags.ApplyTagFilter(tc.filter, tc.input)
			assert.Equal(t, tc.expected, actual)
		})
	}
}
