package lib

import (
	"io"
	"os"
)

func ReadFile(path string) (string, error) {
	ret, err := os.ReadFile(path)
	if err != nil {
		return "", err
	}
	return string(ret), nil
}
func WriteFile(path, data string) error {
	return os.WriteFile(path, []byte(data), 0644)
}

func CopyFile(src, dst string) (err error) {
	in, err := os.Open(src)
	if err != nil {
		return
	}

	defer in.Close()

	out, err := os.Create(dst)
	if err != nil {
		return
	}

	defer func() {
		cerr := out.Close()
		if err == nil {
			err = cerr
		}
	}()

	if _, err = io.Copy(out, in); err != nil {
		return
	}

	err = out.Sync()

	return
}

func MoveFile(src, dst string) (err error) {
	err = CopyFile(src, dst)
	if err != nil {
		return
	}

	return os.Remove(src)
}
